{
Copyright () 2005,  by Germn Estvez (Neftal)
http://neftali.clubdelphi.com/

  Muestra cmo mover componenntes visuales en ejecucion utilizando el mouse.

=========================================================================
IMPORTANTE PROGRAMADORES: Por favor, si tienes comentarios, mejoras, ampliaciones,
  errores y/o cualquier otro tipo de sugerencia envame un mail a:
  german_ral@hotmail.com

IMPORTANT PROGRAMMERS: please, if you have comments, improvements, enlargements,
errors and/or any another type of suggestion send a mail to:
german_ral@hotmail.com
=========================================================================

@author Germn Estvez (Neftal)
@cat Samples
}
unit Umover_imagen;

//=========================================================================
//
// I N T E R F A C E
//
//=========================================================================
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Image1: TImage;
    Button1: TButton;
    Button2: TButton;
    btnCerrar: TButton;
    Edit1: TEdit;
    Button3: TButton;
    ListBox1: TListBox;
    CheckBox1: TCheckBox;
    Bevel1: TBevel;
    BitBtn1: TBitBtn;
    Label1: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure MouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Image1DblClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure btnCerrarClick(Sender: TObject);

  private
    Capturing:Boolean;
    MouseDownSpot:TPoint;
    nmesas:Integer;
    Last:TControl;

    procedure Delete(img:TImage);

  public
    { Public declarations }
  end;

var
  Form1: TForm1;

//=========================================================================
//
// I M P L E M E N T A T I O N
//
//=========================================================================
implementation

{$R *.dfm}

procedure TForm1.MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if Capturing then begin
    TControl(Sender).Left := TControl(Sender).Left - (MouseDownSpot.x - x);
    TControl(Sender).Top := TControl(Sender).Top - (MouseDownSpot.y - y);
  end;
end;

procedure TForm1.MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Capturing then begin
    ReleaseCapture;
    Capturing := false;
    TControl(Sender).Left := TControl(Sender).Left - (MouseDownSpot.x - x);
    TControl(Sender).Top := TControl(Sender).Top - (MouseDownSpot.y - y);
  end;

  if (Sender is TControl) then begin
    Last := TControl(Sender);
  end;

end;

procedure TForm1.MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Capturing := true;
  MouseDownSpot.X := x;
  MouseDownSpot.Y := Y;
end;


procedure TForm1.Button1Click(Sender: TObject);
begin
  with timage.Create(Image1) do
  begin
    // Crear
    picture := Image1.picture;
    // Props
    name := 'MS_' + inttostr(nmesas);
    nmesas := nmesas + 1;
    Stretch := True;
    Parent := Panel1;
    Left := 10;
    Top := 10;
    height := 57;
    width := 61;
    Transparent := true;

    // Eventos
    onMouseDown := MouseDown;
    onMouseMove := MouseMove;
    onMouseUp := MouseUp;
    onDblClick := Image1DblClick;
  end;

  // Crear el Circulo
  with TShape.Create(Self) do
  begin
    // Crear
    name := 'SH_' + inttostr(nmesas);
    nmesas := nmesas + 1;
    // props
    Parent := Panel1;
    Left := 10;
    Top := 10;
    height := 57;
    width := 61;
    Shape := stCircle;

    // Eventos
    onMouseDown := MouseDown;
    onMouseMove := MouseMove;
    onMouseUp := MouseUp;
    onDblClick := Image1DblClick;
  end;

  // Crear un lnea
  with TShape.Create(Self) do
  begin
    // Crear
    name := 'SH_' + inttostr(nmesas);
    nmesas := nmesas + 1;
    // props
    Parent := Panel1;
    Left := 80;
    Top := 10;
    height := 2;
    width := 61;
    Shape := stRectangle;

    // Eventos
    onMouseDown := MouseDown;
    onMouseMove := MouseMove;
    onMouseUp := MouseUp;
    onDblClick := Image1DblClick;
  end;

end;

procedure TForm1.Image1DblClick(Sender: TObject);
begin
  if (Sender is TiMAGE) then begin
    // Borrar
    Delete(Timage(sender));
  END;
end;

procedure TForm1.Delete(img: TImage);
begin
  img.Free;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if Assigned (Last) then begin
    Last.Free;
    Last := nil;
  end;
end;

procedure TForm1.btnCerrarClick(Sender: TObject);
begin
  Close;
end;

end.

